﻿Module Module1

    Private X, Y, XDim, YDim
    Private Fish(,)      ' presence or absense of a fish at point
    Private Shark(,)     ' presence or absense of a shark at point
    Private Chronons As Integer
    Dim NFish As Integer      ' # of sharks in the beginning
    Dim NSharks As Integer   ' # of fish in the beginning
    Dim isDisplay As Boolean
    Dim inited As Boolean

    '===========================================================================
    ' Subject: WATOR SIMULATION                   Date: Unknown Date (00:00)   
    '  Author: Victor Yiu                         Code: QB, QBasic, PDS        
    '  Origin: WATOR,SIMULATION                 Packet: AI.ABC
    '===========================================================================

    Sub Main()
        Console.ForegroundColor = ConsoleColor.White
        Console.BackgroundColor = ConsoleColor.DarkBlue
        Console.Clear()
        Console.BackgroundColor = ConsoleColor.DarkMagenta
        Console.WriteLine("Wa-Tor:    ")
        Console.ForegroundColor = ConsoleColor.Yellow
        Console.WriteLine("Sharks and fish wage an ecological war on the toroidal planet Wa - Tor.")
        ClearBot()
        Console.SetCursorPosition(0, 2)
        Console.ForegroundColor = ConsoleColor.Gray
        Console.BackgroundColor = ConsoleColor.DarkBlue

        Dim X1$
        Do : Console.Write("X Size of Wa-Tor [40]? ") : X1$ = Console.ReadLine
            X = Val(X1$)
            If X = 0 Then XDim = 40 Else XDim = X
        Loop Until (XDim <= 40) And (XDim > 1)

        Do : Console.Write("Y Size of Wa-Tor [23]? ") : Dim Y1$ = Console.ReadLine
            Y = Val(Y1$)
            If Y = 0 Then YDim = 23 Else YDim = Y
        Loop Until (YDim <= 23) And (YDim > 1)

        Dim TotalSpots As Integer = XDim * YDim * 9 \ 10 ' total # of positions

        NFish = TotalSpots \ 2      ' # of sharks in the beginning
        NSharks = TotalSpots \ 20   ' # of fish in the beginning

        Dim FBreed As Integer
        Do : Console.Write("Chronons required for fish to breed [8]? ") : X1$ = Console.ReadLine
            X = Val(X1$)
            If X = 0 Then FBreed = 8 Else FBreed = X
        Loop Until FBreed >= 1

        Dim SBreed As Integer
        Do : Console.Write("Chronons required for sharks to breed [10]? ") : X1$ = Console.ReadLine
            X = Val(X1$)
            If X = 0 Then SBreed = 10 Else SBreed = X
        Loop Until SBreed >= 1

        Dim Starve As Integer
        Do : Console.Write("How long can a shark live without fish [3]? ") : X1$ = Console.ReadLine
            X = Val(X1$)
            If X = 0 Then Starve = 3 Else Starve = X
        Loop Until Starve >= 1

        Console.WriteLine()
        Console.Write("Chronons per second (0 = not timed) [0]? ") : X1$ = Console.ReadLine
        Dim PerSecond As Integer = Val(X1$)
        Dim Interval!
        If PerSecond Then Interval! = 1 / PerSecond

        Console.ForegroundColor = ConsoleColor.Yellow
        Console.BackgroundColor = ConsoleColor.DarkMagenta
        Center(25, "Initializing...")

        ReDim Fish(XDim, YDim)      ' presence or absense of a fish at point
        ReDim Shark(XDim, YDim)     ' presence or absense of a shark at point
        Dim FishMove(XDim, YDim)  ' record of whether a fish has been  moved
        '   there during the current computational
        '   cycle
        Dim SharkMove(XDim, YDim) ' ditto
        Dim Starve2(XDim, YDim)    ' registers the last time the sharks ate

        For Dummy = 1 To XDim
            For Dummy2 = 1 To YDim
                Fish(Dummy, Dummy2) = -1    ' none here for the moment
                Shark(Dummy, Dummy2) = -1
            Next
        Next

        Dim LocX As Integer
        Dim LocY As Integer
        For Fill = 1 To NFish       ' fill Wa-Tor with fish
            Randomize()

            Do      ' make sure it's not occupied by another fish already
                LocX = Int(Rnd() * XDim + 1)   ' positions
                LocY = Int(Rnd() * YDim + 1)
            Loop Until (Fish(LocX, LocY) = -1)

            Fish(LocX, LocY) = Int(Rnd() * FBreed)  ' say fish is here; stage of life
        Next

        For Fill = 1 To NSharks
            Randomize()

            Do      ' make sure it's not occupied by another fish or shark already
                LocX = Int(Rnd() * XDim + 1)   ' positions
                LocY = Int(Rnd() * YDim + 1)
            Loop Until (Fish(LocX, LocY) = -1) And (Shark(LocX, LocY) = -1)

            Shark(LocX, LocY) = Int(Rnd() * SBreed) ' say shark is here!; stage of life
            Starve2(LocX, LocY) = Int(Rnd() * Starve)       ' last time ate?
        Next

        ClearBot()

        ''VIEW Print 2 To 24
        Console.SetCursorPosition(0, 23)
        Console.ForegroundColor = ConsoleColor.Gray
        Console.BackgroundColor = ConsoleColor.DarkBlue
        ''For Dummy = 1 To 24 : Console.WriteLine() : Next
        ''VIEW Print

        Display()

        Dim T!
        Dim OkX(), Oky()
        Dim numPos As Integer
        Dim Choice As Integer
        Dim NewX As Integer
        Dim NewY As Integer
        Dim SingleStep As Integer
        Dim i$

        Do
            If PerSecond Then T! = Timer

            ReDim OkX(4), Oky(4)

            For X = 1 To XDim      ' moving fish
                For Y = 1 To YDim
                    If Fish(X, Y) > -1 Then    ' there's a fish here
                        If FishMove(X, Y) = 0 Then  ' and hasn't been moved yet

                            OkFishMoves(OkX, Oky, Fish, Shark, numPos)
                            ' find the ok positions to move to
                            If numPos > 0 Then   ' a place to move to!
                                Randomize()
                                Choice = Int(numPos * Rnd()) + 1

                                NewX = OkX(Choice)  ' new pos.
                                NewY = Oky(Choice)

                                If Fish(X, Y) >= FBreed Then    ' breeding time?
                                    Fish(NewX, NewY) = 0        ' reset life
                                    Fish(X, Y) = 0

                                    NFish = NFish + 1
                                    FishMove(X, Y) = 1          ' say we have changed
                                    FishMove(NewX, NewY) = 1        ' already
                                Else
                                    Fish(NewX, NewY) = Fish(X, Y) + 1
                                    Fish(X, Y) = -1
                                    FishMove(NewX, NewY) = 1
                                End If
                            End If  ' none possible
                        End If  ' moved already
                    End If  ' no fish there
                Next
            Next


            'shark time -- complications...
            For X = 1 To XDim
                For Y = 1 To YDim
                    If Shark(X, Y) > -1 Then    ' there's a shark here
                        If SharkMove(X, Y) = 0 Then     ' it hasn't been moved yet
                            NewX = 0
                            NewY = 0

                            OkSharkMoves(OkX, Oky, Fish, Shark, numPos)

                            Randomize()

                            If numPos > 0 Then      ' places with fish to move to
                                Choice = Int(numPos * Rnd()) + 1

                                NewX = OkX(Choice)
                                NewY = Oky(Choice)

                                If Shark(X, Y) = SBreed Then    ' breeding time?
                                    Shark(NewX, NewY) = 0
                                    Shark(X, Y) = 0
                                    Starve2(NewX, NewY) = 0
                                    Starve2(X, Y) = 0
                                    Fish(NewX, NewY) = -1

                                    NSharks = NSharks + 1
                                    NFish = NFish - 1
                                    SharkMove(NewX, NewY) = 1
                                    SharkMove(X, Y) = 1
                                Else
                                    Shark(NewX, NewY) = Shark(X, Y) + 1
                                    Shark(X, Y) = -1
                                    Starve2(NewX, NewY) = 0
                                    Starve2(X, Y) = -1
                                    Fish(NewX, NewY) = -1

                                    NFish = NFish - 1
                                    SharkMove(NewX, NewY) = 1
                                End If
                            ElseIf numPos < 0 Then ' no fish positions, but just move
                                Choice = Int(Math.Abs(numPos) * Rnd()) + 1

                                NewX = OkX(Choice)
                                NewY = Oky(Choice)

                                If Shark(X, Y) = SBreed Then    ' breeding time?
                                    Shark(NewX, NewY) = 0
                                    Shark(X, Y) = 0
                                    Starve2(NewX, NewY) = Starve2(X, Y) + 1
                                    ' *********** Should the baby be full when born? Or should it new food?

                                    Starve2(X, Y) = Starve - 2

                                    NSharks = NSharks + 1
                                    SharkMove(NewX, NewY) = 1
                                    SharkMove(X, Y) = 1
                                Else
                                    Shark(NewX, NewY) = Shark(X, Y) + 1
                                    Shark(X, Y) = -1
                                    Starve2(NewX, NewY) = Starve2(X, Y) + 1
                                    Starve2(X, Y) = -1

                                    SharkMove(NewX, NewY) = 1
                                End If
                            Else    ' can't move at all!
                                Shark(X, Y) = Shark(X, Y) + 1
                                Starve2(X, Y) = Starve2(X, Y) + 1
                                'SharkMove(X,Y)=1
                            End If

                            If Starve2(X, Y) >= Starve Then
                                Shark(X, Y) = -1  ' died
                                NSharks = NSharks - 1
                            End If
                            If NewX > 0 Then
                                If Starve2(NewX, NewY) >= Starve Then
                                    Shark(NewX, NewY) = -1  ' died
                                    NSharks = NSharks - 1
                                End If
                            End If
                        End If  ' moved already
                    End If  ' no shark here
                Next
            Next

            Chronons = Chronons + 1     ' next year

            ReDim FishMove(XDim, YDim)    ' clear moved flags
            ReDim SharkMove(XDim, YDim)

            Display()         ' display progress (YESSS!!!)

            ''TODO: read keys
            If SingleStep = 1 Then
                i$ = Console.ReadLine
                If UCase(i) = "P" Then SingleStep = 0
                If UCase(i) = "E" Then Exit Do
            Else
                ''i$ = Console.ReadLine
                i$ = ""
                i$ = i$.ToUpper

                If i = "P" Then
                    i$ = Console.ReadLine
                    If UCase(i) <> "P" Then SingleStep = 1
                ElseIf i = "E" Then
                    Exit Do
                End If
            End If

            If PerSecond And (SingleStep = 0) Then
                Dim E! = Timer
                If (E! - T!) < Interval! Then
                    Do : Loop Until ((Timer - T!) >= Interval!) Or (Timer < T!)
                End If
            End If

        Loop Until (NSharks = 0) Or (NFish = 0)

        Console.ForegroundColor = 14
        Console.BackgroundColor = 5
        Console.SetCursorPosition(11, 0)
        Console.Write("Press any key to exit..." + Space(45))

        i$ = Console.ReadLine
        End

    End Sub

    Sub Center(Lin As Integer, Text$)

        Console.SetCursorPosition(((81 - Len(Text$)) \ 2) - 1, Lin - 1)
        Console.Write(Text$)

    End Sub

    Sub ClearBot()

        Console.ForegroundColor = ConsoleColor.White
        Console.BackgroundColor = ConsoleColor.DarkCyan
        Console.SetCursorPosition(0, 24)
        Console.Write(StrDup(80, Chr(0)))

    End Sub

    Sub Display()

        ''Shared Fish(), Shark(), XDim, YDim, Chronons, NFish, NSharks

        Dim Temp$ = Space(XDim + XDim)

        Console.ForegroundColor = ConsoleColor.Gray
        Console.BackgroundColor = ConsoleColor.DarkBlue
        For Y = 1 To YDim
            Dim Counter = 1
            For X = 2 To XDim + XDim Step 2
                If Fish(Counter, Y) > -1 Then   ' fish?
                    MID$(Temp$, X) = "o"
                ElseIf Shark(Counter, Y) > -1 Then  ' shark?
                    MID$(Temp$, X) = Chr(Asc("x"))
                Else                            ' nope, it's just blank
                    MID$(Temp$, X) = Chr(32)
                End If
                Counter = Counter + 1
            Next

            Console.SetCursorPosition(0, Y)
            Console.Write(Temp$)
        Next

        Console.SetCursorPosition(0, 24)

        If isDisplay = False Then
            isDisplay = True
            ''If SCREEN(25, 1) <> 179 Then
            Console.ForegroundColor = ConsoleColor.White
            Console.BackgroundColor = ConsoleColor.DarkCyan
            '                        22v            37v            42v
            Console.Write("|Status|  Chronons:      Fish pop (o):      Shark pop(x):  ³")
            Console.Write("        P     E")
            Console.ForegroundColor = ConsoleColor.Yellow
            Console.CursorLeft = 69
            Console.Write("ause/")
            Console.CursorLeft = Console.CursorLeft + 1
            Console.Write("xit  ")
        End If

        Console.CursorLeft = 19
        ''LOCATE , 20, 0

        Console.ForegroundColor = ConsoleColor.Yellow
        Console.BackgroundColor = ConsoleColor.DarkCyan
        Console.Write(Chronons.ToString & "  ")
        Console.CursorLeft = 38
        Console.Write(NFish.ToString & "  ")
        Console.CursorLeft = 57
        Console.Write(NSharks.ToString & "  ")
    End Sub

    Sub OkFishMoves(ByRef OkX(), ByRef OkY(), ByRef Fish(,), ByRef Shark(,), ByRef PP)
        ' PP=Possible Positions
        PP = 0

        ' left
        Dim tempX
        Dim tempY
        If X = 1 Then tempX = XDim Else tempX = X - 1
        tempY = Y
        If (Fish(tempX, tempY) = -1) And (Shark(tempX, tempY) = -1) Then
            PP = PP + 1
            OkX(PP) = tempX
            OkY(PP) = tempY
        End If

        ' right
        If X = XDim Then tempX = 1 Else tempX = X + 1
        If (Fish(tempX, tempY) = -1) And (Shark(tempX, tempY) = -1) Then
            PP = PP + 1
            OkX(PP) = tempX
            OkY(PP) = tempY
        End If

        ' up
        If Y = 1 Then tempY = YDim Else tempY = Y - 1
        tempX = X
        If (Fish(tempX, tempY) = -1) And (Shark(tempX, tempY) = -1) Then
            PP = PP + 1
            OkX(PP) = tempX
            OkY(PP) = tempY
        End If

        ' down
        If Y = YDim Then tempY = 1 Else tempY = Y + 1
        If (Fish(tempX, tempY) = -1) And (Shark(tempX, tempY) = -1) Then
            PP = PP + 1
            OkX(PP) = tempX
            OkY(PP) = tempY
        End If

    End Sub

    Sub OkSharkMoves(ByRef OkX(), ByRef OkY(), ByRef Fish(,), ByRef Shark(,), ByRef PP)
        ' PP=Possible Positions
        ' if will be returned negated if only no-fish places are found...

        Dim NoFishX(XDim), NoFishY(YDim)
        If Not inited Then
            ReDim NoFishX(XDim), NoFishY(YDim)  ' we will store values
            inited = True                               ' when the
        End If
        ' shark moves and doensn't find a fish at position.
        ' We will store the positions where sharks are found in the "Ok" array.
        PP = 0
        Dim PPnF = 0    ' positions w/o fish

        ' left
        Dim tempX As Integer
        Dim tempY As Integer
        If X = 1 Then tempX = XDim Else tempX = X - 1
        tempY = Y

        If Shark(tempX, tempY) = -1 Then    ' make sure there's no shark
            If Fish(tempX, tempY) > -1 Then   'fish found in this place
                PP = PP + 1
                OkX(PP) = tempX
                OkY(PP) = tempY
            Else    ' ohh, no fish.  Anybody for tuna I bought at the grocers?
                PPnF = PPnF + 1
                NoFishX(PPnF) = tempX

                NoFishY(PPnF) = tempY
            End If
        End If

        ' right
        If X = XDim Then tempX = 1 Else tempX = X + 1
        If Shark(tempX, tempY) = -1 Then    ' make sure there's no shark
            If Fish(tempX, tempY) > -1 Then   'fish found in this place
                PP = PP + 1
                OkX(PP) = tempX
                OkY(PP) = tempY
            Else    ' ohh, no fish.  Anybody for tuna I bought at the grocers?
                PPnF = PPnF + 1
                NoFishX(PPnF) = tempX

                NoFishY(PPnF) = tempY
            End If
        End If

        ' up
        If Y = 1 Then tempY = YDim Else tempY = Y - 1
        tempX = X
        If Shark(tempX, tempY) = -1 Then    ' make sure there's no shark
            If Fish(tempX, tempY) > -1 Then   'fish found in this place
                PP = PP + 1
                OkX(PP) = tempX
                OkY(PP) = tempY
            Else    ' ohh, no fish.  Anybody for tuna I bought at the grocers?
                PPnF = PPnF + 1
                NoFishX(PPnF) = tempX

                NoFishY(PPnF) = tempY
            End If
        End If

        ' down
        If Y = YDim Then tempY = 1 Else tempY = Y + 1
        If Shark(tempX, tempY) = -1 Then    ' make sure there's no shark
            If Fish(tempX, tempY) > -1 Then   'fish found in this place
                PP = PP + 1
                OkX(PP) = tempX
                OkY(PP) = tempY
            Else    ' ohh, no fish.  Anybody for tuna I bought at the grocers?
                PPnF = PPnF + 1
                NoFishX(PPnF) = tempX

                NoFishY(PPnF) = tempY
            End If
        End If

        If PP = 0 Then  ' since there is no fish around me, just move on
            If PPnF > 0 Then    ' other places not occupied
                PP = -PPnF

                For Copy = 1 To PPnF
                    OkX(Copy) = NoFishX(Copy)
                    OkY(Copy) = NoFishY(Copy)
                Next
            End If  ' no place to go!!
        End If
        Exit Sub

CheckS:
        If Shark(tempX, tempY) = -1 Then    ' make sure there's no shark
            If Fish(tempX, tempY) > -1 Then   'fish found in this place
                PP = PP + 1
                OkX(PP) = tempX
                OkY(PP) = tempY
            Else    ' ohh, no fish.  Anybody for tuna I bought at the grocers?
                PPnF = PPnF + 1
                NoFishX(PPnF) = tempX

                NoFishY(PPnF) = tempY
            End If
        End If
        Return

    End Sub

End Module
